#include <stdio.h>
#include <time.h>

#include "total.h"				// 饹 Total_system 
#include "p_tmp.h"
#include "kinem.h"

class TestKinem : public Total_system {

/* ü */
  protected:
	I_file<double> ipu[2];
	I_file<double> ipl;
	void Register_input_ports(void)
	{
		Register((void*) &(ipu[0]));
		Register((void*) &(ipu[1]));
		Register((void*) &(ipl));
	}
	
/* ü */
  protected:
	O_file<double> outp;
	void Register_output_ports(void)
	{
		Register((void*) &outp);
	}
		
/* ֥ */
  protected:
	Kinem stream;
	void Register_components(void)
	{
		Register((void*) &stream);
	}

	void Register_iterators(void) {}
		
/* ³ */
  protected:
	void Connect_ports(void)
	{
		Connect(((void*) &ipu[0]), ((void*) &stream),
				"Receive", "rpu", 0);
		Connect(((void*) &ipu[1]), ((void*) &stream),
				"Receive", "rpu", 1);
		Connect(((void*) &ipl), ((void*) &stream),
				"Receive", "rpl", 0);
		Connect(((void*) &stream), "Send", "sp", 0,
				((void*) &outp));
	}
	
	void Connect_components(void) {}

/* 󥹥ȥ饯 */
  public:
	TestKinem(void)
		:	Total_system(),
			ipl("tkinem.ipl"),
			outp("tkinem.out"),
			stream("stream", 0, 2, 1)
	{
		class_name = "TestKinem";
		ipu[0].Init("tkinem.ipu0");
		ipu[1].Init("tkinem.ipu1");
		Init("total_system", 0, 0);
	}
};



/* ᥤץ */

int main(void)
{
	TestKinem total_system;		// ηϥǥ
	
	total_system.Set_ohymos_option();		// simulation option 

	if (total_system.Construct() != YES)
		{ printf("\n# Failure : Construct.\n"); return 1; }
	
	if (total_system.Switch() != YES)
		{ printf("\n# Failure : Switch.\n"); return 1; }
	
	if (total_system.Are_you_ready() != YES)
		{ printf("\n# Failure : Are_you_ready.\n"); return 1; }
	
	// ѥ᥿ե뤫ɤߤȤ
	total_system.Read_parameter_file("tkinem.pmt");

	// ֤ե뤫ɤߤȤ
	total_system.Read_initial_state_file("tkinem.ist");

	// üҥǡꥹȥ
	total_system.Read_send_port_file("tkinem.isd");
	
	total_system.Initial_work();
	total_system.Work();
	
	// ǽ֤ե¸
	total_system.Write_terminal_state("tkinem.tst");

	// üҤ˻ĤäƤǡե¸
	total_system.Write_send_port_stock("tkinem.tsd");
	return 0;
}
